include ht48e30.inc

		EXTERN	addID:near,getID:near,pulseLock:near,OpenLock:near,HSdelay:near
		EXTERN	purgeDB:near,numID:near,matchID:near

Purge	equ	PG.0

vars	.section 'DATA'
IDs		db ?					; # IDs in DB

reset	.section at 0 'CODE'
		ORG 0
		jmp start

		ORG 00Ch
start:  clr	PC			; 
		clr PB 
        set PAC					; PA0-7 = inputs
        mov a,0F1h				; PB1-3 = outputs, PB0,4-7 = inputs
		mov PBC,a
	    clr PCC					; PC0-7 = outputs
		set PGC					; PG0 = input
		mov A,01h
		mov BP,A 				; set to bank 1
		mov A,040h
		mov MP1,A 				; set MP1 to EECR address
		call numID				; Get # IDs in A
		mov IDs,A
		sz ACC					; Z means none, get master
		jmp main
		jmp GetMaster
main:	call getID				; Wait for an ID
		call matchID			; Search in database
		sz Z					; Match ?
		jmp main				; No, loop
		sub A,IDs				; Check if Master
		sz Z					; Master ?
		jmp Special				; Yes, enter auth mode / purge
open:	call OpenLock			; No, just open
		jmp main

Special:
		call pulseLock			; Acknowledge (2 short pulses)
		call HSdelay
		call pulseLock
		sz Purge				; purge ?
		jmp DOPurge
		call getID				; no, Wait for an ID
		call matchID			; Search in database
		sz Z					; Match ?
		jmp learn				; No, learn
		sub A,IDs				; Check if Master
		snz Z					; Master ?
		jmp Special				; No, ignore
		jmp open				; Yes, exit auth mode (ack by open)
learn:	call addID				; add to DB
		call OpenLock			; acknowledge by opening (ignore errors)
		jmp start

DOPurge:
		call purgeDB			; Purge database
		call HSdelay			; Acknowledge (3 short pulses)
		call pulseLock
		jmp start				; restart

GetMaster:
		call pulseLock			; Acknowledge (1 short pulse)
		call HSdelay
		call getID				; Wait for an ID
		call addID				; Store
		call pulseLock			; Acknowledge (1 short pulse)
		call HSdelay
		jmp start				; restart

		end
