; *********************************************************
; ID reading/converting/checking routines
;
include ht48e30.inc

MAXIDs	equ	24

		EXTERN	receive:near,EEADDR:byte,EEDATA:byte,READ:near,WRITE:NEAR,EWEN:near,EWDS:near


id_vars	.section 'DATA'
aux		db ?		; for calculations
charcnt	db ?		; count chars to get
IDbuf	db 5 DUP(?)

; EEPROM addresses
NUMIDs	EQU 0			; # IDs stored
IDs		EQU	1			; ID storage address


id_code	.section 'CODE'

getID:	call receive					; Wait for STX
		sub A,2							; STX ?
		snz Z
		jmp getID						; No, loop
		mov A,5
		mov charcnt,A					; Init 2* # ID chars to get
		mov A,OFFSET IDbuf				; Initialize pointer
		mov MP0,A
rxloop:	call receive					; Get next char
		call ASCII2bin					; to bin
		mov IAR0,A						; in buffer
		swap IAR0						; high nibble
		call receive					; Get next char
		call ASCII2bin					; to bin
		orm A,IAR0						; in buffer (low nibble)
		inc MP0							; next ID byte
		sdz charcnt						; loop
		jmp rxloop
		call receive					; Wait for CR, discard
		call receive					; Wait for LF, discard
		call receive					; Wait for ETX
		sub A,3							; ETX ?
		snz Z
		jmp getID						; No, loop
		ret

ASCII2bin:
		sub A,041h
		snz C
		add A,7
		add A,10
		ret

addID:	call numID					; Get NUMIDs in A
		mov aux,A					; move to aux var
		sub A,MAXIDs				; Full ?
		sz C
		ret							; then ignore
		mov A,aux
		inc ACC						; add 1 to NUMIDs
		mov EEDATA,A
		call EWEN					; Enable write
		call WRITE					; do it
		clr C						; ID address is 5xNUMIDs
		mov A,aux
		rlc aux						; x2
		rlc aux						; x4
		add A,aux					; x5
		mov EEADDR,A
		inc EEADDR					; offset by NUMIDs
		mov A,5
		mov charcnt,A
		mov A, OFFSET IDbuf			; Initialize pointer
		mov MP0,A
wIDloop:
		mov A,IAR0					; get from buffer
		mov EEDATA,A
		call WRITE					; put to EEPROM
		inc MP0						; next ID byte
		inc EEADDR					; next byte in storage
		sdz charcnt					; loop
		jmp wIDloop
		jmp EWDS		 			; Disable write


numID:	clr EEADDR					; get NUMIDs
		call READ 					; EE Read
		mov A, EEDATA
		ret
		
matchID:
		clr EEADDR					; get NUMIDs
		call READ	 				; EE Read
		mov A,EEDATA
		mov aux,A	 				; Move data to counter
		inc EEADDR					; Point to ID storage
mIDl2:	mov A,5						; Initialize ID lenght
		mov charcnt,A
		mov A,OFFSET IDbuf			; Initialize pointer
		mov MP0,A
mIDl1:	call READ	 				; EE Read
		mov A,EEDATA
		sub A,IAR0					; compare with buffer
		snz Z						; match ?
		jmp mIDnext					; go for next ID
		inc MP0						; next byte in buffer
		inc EEADDR					; next byte in storage
		sdz charcnt					; loop
		jmp mIDl1
		mov A,aux					; MATCH! return ID# in A and Z reset
		clr Z
		ret
mIDnext:
		mov A,charcnt				; point to next ID
		addm A,EEADDR
		sdz aux						; next ID
		jmp mIDl2
		set Z
		ret							; No match, return Z set

purgeDB:
		call EWEN		 			; Enable write
		clr EEADDR					; point to NUMIDs
		mov A,1						; erase all but first ID
		mov EEDATA,A
		call WRITE					; do it
		jmp EWDS					; Disable write


		PUBLIC	getID, addID, matchID, numID, purgeDB

		end



